package show.shanhe.interview.enums.demo;

import org.junit.Test;
import show.shanhe.interview.enums.FourEmperor;
import show.shanhe.interview.enums.I18nEnums;
import show.shanhe.interview.enums.LPL.TES;
import show.shanhe.interview.enums.LPL.JDG;
import show.shanhe.interview.enums.LPL.SN;
import show.shanhe.interview.enums.LPL.LGD;

import java.util.EnumMap;
import java.util.EnumSet;
import java.util.HashMap;
import java.util.Map;

import static show.shanhe.interview.enums.LPL.TES.*;

public class EnumDemo {

    @Test
    public void printFourEmperor() {
        FourEmperor[] values = FourEmperor.values();
        for (FourEmperor value : values) {
            System.out.println(value);
        }
    }

    @Test
    public void printCodeAndDescription() {
        FourEmperor[] fourEmperors = FourEmperor.values();
        for (FourEmperor fourEmperor : fourEmperors) {
            System.out.println(fourEmperor.getCode() + ": " + fourEmperor.getDescription());
        }
    }

    @Test
    public void i18n() {
        System.out.println("中文你好：" + I18nEnums.HELLO.getCn());
        System.out.println("英文你好：" + I18nEnums.HELLO.getEn());
        System.out.println("日文你好：" + I18nEnums.HELLO.getJp());
    }

    @Test
    public void lpl() {
        for (TES tes : TES.values()) {
            System.out.println("TES：" + tes);
        }
        for (JDG jdg : JDG.values()) {
            System.out.println("JDG：" + jdg);
        }
        for (SN sn : SN.values()) {
            System.out.println("SN：" + sn);
        }
        for (LGD lgd : LGD.values()) {
            System.out.println("LGD：" + lgd);
        }
        System.out.println("LPL三连冠");
    }

    @Test
    public void sw() {
        switch (TES.KNIGHT) {
            case THREE_SIX_NINE:
            case KARSA:
            case YUYANJIA:
            case JACKEYLOVE:
                System.out.println("not knight");
                break;
            case KNIGHT:
                System.out.println("mvp");

        }
    }

    @Test
    public void valueOf(){
        TES karsa = Enum.valueOf(TES.class, "KARSA");
        System.out.println(karsa);
    }


    @Test
    public void ordinal() {
        System.out.println(FourEmperor.TES.ordinal() + " : " + FourEmperor.TES.getDescription());
        System.out.println(FourEmperor.JDG.ordinal() + " : " +FourEmperor.JDG.getDescription());
        System.out.println(FourEmperor.SN.ordinal() + " : " + FourEmperor.SN.getDescription());
        System.out.println(FourEmperor.LGD.ordinal() + " : " + FourEmperor.LGD.getDescription());
    }

    @Test
    public void enumMap(){
        Map<TES,String> hashMap = new HashMap<>();
        hashMap.put(THREE_SIX_NINE, "369");
        System.out.println(hashMap);

        EnumMap<TES,String> enumMap = new EnumMap<>(TES.class);
        enumMap.put(KNIGHT, "knight");
        System.out.println(enumMap);
    }

    @Test
    public void enumSet() {
        EnumSet<TES> tes = EnumSet.allOf(TES.class);
        tes.add(THREE_SIX_NINE);
        tes.add(KARSA);
        tes.add(KNIGHT);
        tes.add(JACKEYLOVE);
        tes.add(YUYANJIA);
        System.out.println(tes);
    }
}
